#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#ifndef FALSE
#define FALSE 0
#define TRUE (!FALSE)
#endif

#define BOOLEAN int

#define MAXBC 132

int main (int argc, char *argv[])
{
  char buf[MAXBC+1];
  FILE *afh;
  long nr = 0;
  int xc;
  BOOLEAN verbose;
  int ifname, ichar;

  /* controllo del numero di parametri */

  if (argc != 3 && argc != 4) {
    fprintf (stderr, "errore nei parametri\n");
    exit (1);
  }

  /* controllo ed estrazione dei parametri necessari al programma */

  if (argc == 3)
  {
    verbose = FALSE;
    ifname = 1;
    ichar = 2;
  }
  else /* argc == 4 */
  {
    if (strcmp(argv[1],"-v") != 0) {
      fprintf (stderr, "errore - opzione sconosciuta (%s)\n", argv[1]);
      exit (2);
    }
    verbose = TRUE;
    ifname = 2;
    ichar = 3;
  }

  if (strlen(argv[ichar]) != 1) {
    fprintf (stderr, "errore - l'ultimo parametro deve essere un singolo carattere\n");
    exit (2);
  }
  xc = argv[ichar][0];

  /* apertura del file */

  if ((afh=fopen(argv[ifname],"r")) == NULL) {
    fprintf (stderr,
      "errore - impossibile aprire il file '%s' in lettura\n", argv[ifname]);
    exit (3);
  }

  /* ricerca del carattere all'interno del file */

  while (fgets(buf,MAXBC+1,afh) != NULL)
  {
    if (strchr(buf,xc) != NULL)
    {
      nr++;
      if (verbose) printf ("%s", buf);
    }
  }

  /* presentazione del risultato */

  printf ("%d\n", nr);

  /* chiusura del file */

  if (fclose(afh) != 0)
    fprintf (stderr, "avviso: non riesco a chiudere il file '%s'\n", argv[ifname]);

  /* fine del programma */

  return 0;
}
