#include <stdio.h>
#include <stdlib.h>

#define NOME_FILE_AC "acquisti.txt"
#define NOME_FILE_VE "vendite.txt"
#define MAXBC 127

int main (int argc, char *argv[])
{
  FILE *f_dati, *f_ac, *f_ve;
  unsigned int n_ac = 0, n_ve = 0;
  double v_ac = 0.0, v_ve = 0.0;
  char buf[MAXBC+1];

  /* controllo dei parametri */

  if (argc != 2) {
    fprintf (stderr, "errore - manca il nome del file da cui leggere i dati\n");
    exit (1);
  }

  /* apertura dei file */

  if ((f_dati=fopen(argv[1],"r")) == NULL) {
    fprintf (stderr, "errore - impossibile aprire il file '%s' in lettura\n", argv[1]);
    exit (2);
  }

  if ((f_ac=fopen(NOME_FILE_AC,"w")) == NULL) {
    fprintf (stderr,
      "errore - impossibile aprire il file '%s' in scrittura\n", NOME_FILE_AC);
    exit (3);
  }

  if ((f_ve=fopen(NOME_FILE_VE,"w")) == NULL) {
    fprintf (stderr,
      "errore - impossibile aprire il file '%s' in scrittura\n", NOME_FILE_VE);
    exit (4);
  }

  /* lettura dei dati */

  while (fgets(buf,MAXBC+1,f_dati) != NULL)
  {
    int q;
    double p;

    /* controllo dei dati */

    if (sscanf(buf,"%d %lf", &q, &p) != 2) {
      fprintf (stderr, "errore - riga errata (%s)\n", buf);
      exit (5);
    }

    if (p < 0) {
      fprintf (stderr, "errore - prezzo negativo (%lf)\n", p);
      exit (6);
    }

    /* operazioni */

    if (q < 0) /* vendita */
    {
      n_ve++;
      v_ve += (-q * p);
      fputs (buf, f_ve);
    }
    else /* acquisto */
    {
      n_ac++;
      v_ac += (q * p);
      fputs (buf, f_ac);
    }
  }

  /* stampa dei totali */

  fprintf (f_ac, "operazioni di acquisto: %d\n", n_ac);
  fprintf (f_ac, "valore totale: %.2lf euro\n", v_ac);
  fprintf (f_ve, "operazioni di vendita: %d\n", n_ve);
  fprintf (f_ve, "valore totale: %.2lf euro\n", v_ve);

  /* chiusura dei file */

  if (fclose(f_dati) != 0)
    fprintf (stderr, "avviso - non riesco a chiudere il file '%s'\n", argv[1]);
  if (fclose(f_ac) != 0)
    fprintf (stderr, "avviso - non riesco a chiudere il file '%s'\n", NOME_FILE_AC);
  if (fclose(f_ve) != 0)
    fprintf (stderr, "avviso - non riesco a chiudere il file '%s'\n", NOME_FILE_VE);

  /* fine del programma */

  return 0;
}
