#include <stdio.h>
#include <stdlib.h>

#ifndef FALSE
#define FALSE 0
#define TRUE (!FALSE)
#endif

#define BOOLEAN int

#define MAXBC 127
#define NFILIALI 5

int main (int argc, char *argv[])
{
  char buf[MAXBC+1];
  double fatturato[NFILIALI], val, minv, maxv, totv = 0.0;
  int nf, nval = 0;
  FILE *afh;
  BOOLEAN primo_valore = TRUE;

  if (argc != 3) {
    fprintf (stderr, "errore: fornire nome del file e indice della filiale\n");
    exit (1);
  }

  if ((afh = fopen (argv[1], "r")) == NULL) {
  {
    fprintf (stderr, "errore: non riesco ad aprire il file '%s' in lettura\n", argv[1]);
    exit (2);
  }

  if (sscanf(argv[2],"%d",&nf) != 1) {
    fprintf (stderr, "errore: l'indice della filiale non e' un numero intero\n");
    exit (3);
  }
  if (nf<1 || nf>5) {
    fprintf (stderr, "errore: l'indice della filiale (%s) non e' valido\n", argv[2]);
    exit (4);
  }

  while (fgets(buf,MAXBC+1,afh) != NULL)
  {
    if (sscanf (buf, "%lf %lf %lf %lf %lf",
      &fatturato[0], &fatturato[1], &fatturato[2], &fatturato[3], &fatturato[4]) != 5)
    {
      fprintf (stderr,
        "avviso - questa riga non contiene cinque dati e viene scartata:\n%s\n", buf);
      continue;
    }

    val = fatturato[nf - 1];

    if (primo_valore)
    {
      minv = val;
      maxv = val;
      primo_valore = FALSE;
    }
    else /* non e' il primo_valore */
    {
      if (val < minv)
        minv = val;
      if (val > maxv)
        maxv = val;
    }
    nval++;
    totv += val;
  }

  if (fclose(afh) != 0)
    fprintf (stderr, "avviso: non sono riuscito a chiudere il file '%s'\n", argv[1]);

  if (nval > 0)
    printf ("Filiale n.%d: min=%.2lf max=%.2lf med=%.2lf\n", nf, minv, maxv, totv/nval);
  else
    printf ("Non sono stati forniti dati: impossibile eseguire le statistiche\n");

  return 0;
}
