/**************************************

MODULO: tavnum1.c

SCOPO: tavola dei quadrati, cubi, radquad, radcub
(con limite introdotto da STDIN)

**************************************/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define MAXBC 127
#define LIMIT 1000

int main ()
{
  unsigned i;
  long imax;
  char buf[MAXBC+1];

  printf ("TAVOLA DEI QUADRATI, CUBI, RAD.QUADRATE, RAD.CUBICHE\n\n");

  /* richiedo il limite e controllo che sia stato inserito */

  printf ("Limite della tabella [1...1000]? ");
  if (gets (buf) == NULL)
  {
    fprintf (stderr, "errore - inserire il limite superiore della tabella\n");
    exit (1);
  }

  /* leggo il limite e controllo che sia un numero intero */

  if (sscanf(buf,"%ld",&imax) != 1)
  {
    fprintf (stderr, "errore - il limite inserito (%s) non e' un intero\n", buf);
    exit (2);
  }

  /* controllo il limite introdotto */

  if ((imax < 1) || (imax > LIMIT))
  {
    fprintf (stderr, "errore - il limite inserito (%s) non e' accettabile\n", buf);
    exit (3);
  }

  /* stampo la tabella richiesta */

  for (i=1; i<=imax; i++)
    printf ("%4u %7u %10u %10.6lf %10.6lf\n",
      i, i*i, i*i*i, sqrt((double)i), pow((double)i,(double)1/3));

  return 0;
}

